"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sortBy = sortBy;
exports.enforceSingleNewLine = exports.startsOrEndsWith = exports.pick = exports.mapValues = exports.last = exports.is = exports.head = exports.any = void 0;

const any = (arr, fn = Boolean) => arr.some(fn);

exports.any = any;

const head = arr => arr[0];

exports.head = head;

const is = (type, val) => ![, null].includes(val) && val.constructor === type; // eslint-disable-line no-sparse-arrays


exports.is = is;

const last = arr => arr[arr.length - 1];

exports.last = last;

const mapValues = (obj, fn) => Object.keys(obj).reduce((acc, k) => {
  acc[k] = fn(obj[k], k, obj);
  return acc;
}, {});

exports.mapValues = mapValues;

const pick = (obj, arr) => arr.reduce((acc, curr) => (curr in obj && (acc[curr] = obj[curr]), acc), {}); // eslint-disable-line no-return-assign, no-sequences


exports.pick = pick;

const startsOrEndsWith = (val, query) => val.startsWith(query) || val.endsWith(query);

exports.startsOrEndsWith = startsOrEndsWith;

const enforceSingleNewLine = x => is(String, x) ? x.replace(/[\r\n]+/g, '\n').replace(/[\r\n]*$/, '') : x;

exports.enforceSingleNewLine = enforceSingleNewLine;

function sortBy(key) {
  return (a, b) => {
    if (a[key] === b[key]) return 0;
    return a[key] < b[key] ? 1 : -1;
  };
}