#!/usr/bin/env node
//  ┏━┓┏━┓┏━┓┏━┓┏━╸┏━┓
//  ┣━┛┣━┫┣┳┛┗━┓┣╸ ┣┳┛
//  ╹  ╹ ╹╹┗╸┗━┛┗━╸╹┗╸
//
//  Parser for 30 seconds of code snippets.
//  https://github.com/sQVe/30-seconds-of-code-cli
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeFile = exports.createItem = void 0;

require("core-js/modules/es6.promise");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _util = require("util");

var _snippets = require("../submodules/30-seconds-of-code/snippet_data/snippets.json");

var _helpers = require("./helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const FILE_NAME = 'snippets.json';

const createItem = ({
  id,
  attributes: {
    codeBlocks: [code, example],
    tags,
    text
  }
}) => (0, _helpers.mapValues)({
  code,
  example,
  id,
  tags,
  description: text
}, _helpers.enforceSingleNewLine);

exports.createItem = createItem;

const writeFile = content => (0, _util.promisify)(_fs.default.writeFile)(_path.default.resolve(__dirname, FILE_NAME), JSON.stringify(content));

exports.writeFile = writeFile;

_asyncToGenerator(function* () {
  yield writeFile(_snippets.data.map(createItem));
  console.log(`Successfully created ${FILE_NAME} file.`);
})();